package com.yhy.module.core.dal.mysql.config;

import cn.iocoder.yudao.framework.mybatis.core.mapper.BaseMapperX;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import com.yhy.module.core.dal.dataobject.config.ConfigProjectInfoDO;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;

/**
 * 工程信息配置 Mapper
 *
 * @author yhy
 */
@Mapper
public interface ConfigProjectInfoMapper extends BaseMapperX<ConfigProjectInfoDO> {

    /**
     * 根据配置树节点ID查询列表
     */
    default List<ConfigProjectInfoDO> selectListByConfigTreeId(Long configTreeId) {
        return selectList(new LambdaQueryWrapperX<ConfigProjectInfoDO>()
                .eq(ConfigProjectInfoDO::getConfigTreeId, configTreeId)
                .orderByAsc(ConfigProjectInfoDO::getSortOrder));
    }

    /**
     * 根据父节点ID查询子节点列表
     */
    default List<ConfigProjectInfoDO> selectListByParentId(Long parentId) {
        return selectList(new LambdaQueryWrapperX<ConfigProjectInfoDO>()
                .eqIfPresent(ConfigProjectInfoDO::getParentId, parentId)
                .orderByAsc(ConfigProjectInfoDO::getSortOrder));
    }

    /**
     * 根据配置树节点ID和父节点ID查询
     */
    default List<ConfigProjectInfoDO> selectListByConfigTreeIdAndParentId(Long configTreeId, Long parentId) {
        return selectList(new LambdaQueryWrapperX<ConfigProjectInfoDO>()
                .eq(ConfigProjectInfoDO::getConfigTreeId, configTreeId)
                .eqIfPresent(ConfigProjectInfoDO::getParentId, parentId)
                .orderByAsc(ConfigProjectInfoDO::getSortOrder));
    }

    /**
     * 获取同级最大排序号
     */
    default Integer selectMaxSortOrderByParentId(Long configTreeId, Long parentId) {
        ConfigProjectInfoDO maxSortNode = selectOne(new LambdaQueryWrapperX<ConfigProjectInfoDO>()
                .eq(ConfigProjectInfoDO::getConfigTreeId, configTreeId)
                .eqIfPresent(ConfigProjectInfoDO::getParentId, parentId)
                .orderByDesc(ConfigProjectInfoDO::getSortOrder)
                .last("LIMIT 1"));
        return maxSortNode != null ? maxSortNode.getSortOrder() : 0;
    }
}
